function data = load_data(fname,classes)
% LOAD_DATA
%
% Synopsis:
%  data = load_data(fname,classes)
% 

% Modifications:
% 18-aug-2004, VF

in_data = load(fname);
data = in_data;
data.X = [];
data.y = [];
data.v = [];
data.P = [];
for i=1:length(classes),
  
  tmp = classes{i};
  if size(tmp,1) == 1,
    tmp = [tmp;ones(1,size(tmp,2))];
  end
  lab = tmp(1,:);
  par = tmp(2,:);
  
  for j=1:length(lab),
    inx = find(in_data.y==lab(j));
    num = length(inx);
    
    th = min(num,max(1,round(par(j)*num)));
    inx = inx(1:th);
    
    data.X = [data.X in_data.X(:,inx)];
    data.P = [data.P in_data.P(:,inx)];
    data.y = [data.y i*ones(1,length(inx))];
    data.v = [data.v lab(j)*ones(1,length(inx))];
  end
end

return;
% EOF